<?php

$hasheading = ($PAGE->heading);
$hasnavbar = (empty($PAGE->layout_options['nonavbar']) && $PAGE->has_navbar());
$hasfooter = (empty($PAGE->layout_options['nofooter']));
$hassidepre = (empty($PAGE->layout_options['noblocks']) && $PAGE->blocks->region_has_content('side-pre', $OUTPUT));
$hassidepost = (empty($PAGE->layout_options['noblocks']) && $PAGE->blocks->region_has_content('side-post', $OUTPUT));
$haslogininfo = (empty($PAGE->layout_options['nologininfo']));
$hasdatetime=(!empty($PAGE->theme->settings->datetime));

$showsidepre = ($hassidepre && !$PAGE->blocks->region_completely_docked('side-pre', $OUTPUT));
$showsidepost = ($hassidepost && !$PAGE->blocks->region_completely_docked('side-post', $OUTPUT));

$custommenu = $OUTPUT->custom_menu();
$hascustommenu = (empty($PAGE->layout_options['nocustommenu']) && !empty($custommenu));


$hasuserimgdisb = (empty($PAGE->theme->settings->showuserpicture));

$bodyclasses = array();
if ($showsidepre && !$showsidepost) {
    $bodyclasses[] = 'side-pre-only';
} else if ($showsidepost && !$showsidepre) {
    $bodyclasses[] = 'side-post-only';
} else if (!$showsidepost && !$showsidepre) {
    $bodyclasses[] = 'content-only';
}
if ($hascustommenu) {
    $bodyclasses[] = 'has_custom_menu';
}

if($hasuserimgdisb){
	$bodyclasses[] = 'user_img_disb';
}
if (!empty($PAGE->theme->settings->customfontsize)) {
    $fontsize=13;
	//$PAGE->requires->js_init_call('M.theme_hubris.slider.init',array($fontsize), false, hubris_get_js_module());
	$PAGE->requires->js('/theme/hubris/yui/slider.js');
}

if (!empty($PAGE->theme->settings->floatmenu)) {
       $PAGE->requires->js('/theme/hubris/yui/menu.js');
}
if (!empty($PAGE->theme->settings->backtotop)) {
       $PAGE->requires->js('/theme/hubris/yui/bttotop.js');       
}

if(!empty($PAGE->theme->settings->displaybannerimage)){
	$displaybannerimage = $PAGE->theme->settings->displaybannerimage;
	if (!empty($PAGE->theme->settings->bannerimage)) {
    	$bannerimageurl = $PAGE->theme->settings->bannerimage;
	}else{
		$bannerimage =$OUTPUT->pix_url('images/bnr-1', 'theme');
	}
}else{
	$bannerimage =$OUTPUT->pix_url('images/bnr-1', 'theme');
}
$displaybannerimage = !isset($PAGE->theme->settings->displaybannerimage) || $PAGE->theme->settings->displaybannerimage;

$is_enable_adminmenu=(empty($PAGE->theme->settings->menu_administration) || $PAGE->theme->settings->menu_administration < 1) ? 0 : 1;
$is_enable_navmenu=(empty($PAGE->theme->settings->menu_navigation) ||$PAGE->theme->settings->menu_navigation < 1) ? 0 : 1;
$is_enable_custommenu=(empty($PAGE->theme->settings->menu_custom) ||$PAGE->theme->settings->menu_custom < 1) ? 0 : 1;
$is_disable_moodlelogo = (empty($PAGE->theme->settings->hidemoodlelogo) ||$PAGE->theme->settings->hidemoodlelogo < 1) ? 0 : 1;
$hascustomfontsize = (!empty($PAGE->theme->settings->customfontsize)) ;
$hassocialnetworks=(!empty($PAGE->theme->settings->socialnetworks));

//*************************custom code******************************************

echo $OUTPUT->doctype() ?>
<html <?php echo $OUTPUT->htmlattributes() ?>>
<head>
    <title><?php echo $PAGE->title ?></title>
    <link rel="shortcut icon" href="<?php echo $OUTPUT->pix_url('favicon', 'theme')?>" />
    <meta name="description" content="<?php p(strip_tags(format_text($SITE->summary, FORMAT_HTML))) ?>" />
    <?php echo $OUTPUT->standard_head_html() ?>
</head>
<body id="<?php p($PAGE->bodyid) ?>" class="<?php p($PAGE->bodyclasses.' '.join(' ', $bodyclasses)) ?>">
<?php echo $OUTPUT->standard_top_of_body_html() ?>
    
    <div id="page">
    
      <!--       <div id="menubg"> -->
          <?php if ($is_enable_adminmenu || $is_enable_navmenu || ($hascustommenu && $is_enable_custommenu)) {?>
              <div class="clearfix"></div>
        		 <div id="menucontainer">
        		    <div id="awesomebar">
        	  <?php
        			$topsettings = $this->page->get_renderer('theme_hubris','topsettings');

        			$siteadmin = $topsettings->settings_tree($this->page->settingsnav);
        			$navigation = $topsettings->navigation_tree($this->page->navigation);
        			hubris_position_menus($siteadmin, $navigation, $hascustommenu, $custommenu);
          ?>
          </div>       
      </div>
      <?php }else{ ?>
	   <hr id="menubtm" style="background: #174da1" />

    <?php } ?>
  <!-- </div> -->
  <div class="clearfix"></div>
   
      <div id="page-header" class="clerarfix" style="background: #174da1;height: 250px;">

   
   <div id="header-containerwrappmain">    
     <div id="header-containerwrapp">
         
         <div style="float:left">
              <img style="float:left" src="<?php echo "http://www.mope.es/aula-virtual/theme/hubris/img/cabeceraIzquierda.png"?>" alt="" />
         </div>
         
         <!-- TITULO CABECERA-->
         <div id="headingmenu" style="width: 58%;text-align: center">
          <?php  if ($displaylogo) { ?>
				<h1 class="headermain-logo">
                                    <img src="<?php echo $logourl?>" alt="" /><br/><?php echo $tagline; ?></h1>
		   <?php }else{?>
				<!--<h1 class="headermain" style="float:initial;"><?php echo $PAGE->heading ?></h1>-->
            
		<h1 class="" style=" font-size: 36px;color: hsl(0, 100%, 100%);font-weight: normal;padding: 10px 0px;line-height: 54px;margin: 40px 5px;height: auto;">
                    <?php //echo $PAGE->heading ?>
                    PLATAFORMA VIRTUAL
                </h1>
               <?php }?>	
        	</div>
          <div style="float:right">
              <img style="float:right" src="http://www.mope.es/aula-virtual/theme/hubris/img/cabeceraDerecha.png" alt="" />
         </div>
       <!-- NOMBRE USUARIO E IDIOMA-->  
       <!--<div id="profilename" class="headermenu">-->
       <div id="profilename">
	    <?php 
	    GLOBAL	$CFG;
		 if(isloggedin()){
			?>
			 <?php
                                if (!empty($PAGE->theme->settings->showuserpicture)){ 
                                ?>
                                <div class="userpic-wrapp">
                              <div class="userpic">
                                        <div id="profilepicture">
                                                <?php 
                                                        echo $OUTPUT->user_picture($USER, array('size'=>90));
                                                ?>
                                        </div>
                                 </div>
                      </div>
                                <?php }
                        ?>  
					<div class="mylogin" style="">
					    <div class="userprof">
					       <!--<h1> <?php //echo get_string('usergreeting', 'theme_hubris', $USER->firstname .' '. $USER->lastname); ?> </h1>-->
					    <h1> <?php echo "Hola ". $USER->firstname .' '. $USER->lastname?> </h1>
					  
                                            </div>
					    <div class="clearfix"></div>					    					
                            <?php  if ($hascustomfontsize){ ?>
			                  <div id="fontContWrap">
	                            <div class="plus" id="yui-font-plus">+</div><div class="minus" id="yui-font-minus">-</div>
         	                  </div>
         	                <?php } ?>
         	                <div class="clearfix"></div>
					    <?php echo $OUTPUT->lang_menu(); ?>
						<div class="clearfix"></div>
					</div>
				
			<?php
		}else{
			?>
			 <div class="username"><h1> <?php echo get_string('notloggedin', 'theme_hubris' )?> <a href="<?php echo new moodle_url('/login/index.php', array('sesskey'=>sesskey())), get_string('login') ?> " > <?php echo get_string('login') ?></a> </h1></div>
			 <div class="clearfix"></div>

			 <div class="profilename">
			   <?php echo $OUTPUT->lang_menu(); ?>
			 </div>
			<?php
		}
		echo $PAGE->headingmenu;	
	   ?>
	   </div>
       <div style="float:left;font-size: 17px;color:#FFF;font-weight: normal;margin-left: 20px; margin: 4px;">
           TU FORMACIÓN, TU FUTURO
       </div>
       <!--imagen anterior cabecera-->
	      <div id="bnrimg">
           <?php  if ($displaybannerimage) { 
           				if(!empty($bannerimageurl)){
           				?>
           					 <!--<img src="<?php echo $bannerimageurl ?>" alt="" />-->
           					 
           					<?php 
           				}else{
           				?>
           					<!--<img src="<?php echo $bannerimage ?>" alt="" />-->
                                                    <?php
           				}

           			?>
				
		   <?php }else{?>
			  
				<img src="<?php echo $bannerimage ?>" alt="" />
		   <?php }?>	
         </div>
         </div>
          <div class="clearfix"></div>
        </div> 
          <div class="clearfix"></div>
      </div>
       <div class="clearfix"></div>                     
<!-- END OF HEADER -->

<div id="mainContainer">
<div id="date-login">
      <?php if ($hasdatetime) {?>
            
                <?php
                    $topsettings = $this->page->get_renderer('theme_hubris','topsettings');
        			if (!empty($PAGE->theme->settings->datetime)) {?>
        			<div class="dtevent">
					         <?php echo $topsettings->display_date(); ?>
					 </div>        
						   <?php } ?>
            
            <?php } ?>
            
    <div class="login-area">

	<?php 
	 GLOBAL	$CFG;
		if(isloggedin()){
			?>
				<div id="profileoption" class="profileoption">
					<?php
							//echo $PAGE['langmenu'];
							if(( empty($PAGE->theme->settings->showuserpicture) && $CFG->langmenu == 0)){
								$c_class = "mylist disable_pic_lan";
							}else{
								$c_class ="mylist";
							}
						?>
				
					<div class="mylogin">	
						<ul class="<?php echo $c_class; ?>">
						    
							<li>
									
								<a href="<?php echo new moodle_url('/user/profile.php?id='.$USER->id.'&amp;course='.$COURSE->id); ?>"><?php echo get_string('userprofile', 'theme_hubris'); ?></a>
							</li>
							
							<li>
								<a href="<?php echo new moodle_url('/course/index.php') ?> "><?php echo get_string('mycourses'); ?></a>	
							</li>
							
							<li>
								<?php
								if(isguestuser()){
								
								?>
									<a href="<?php echo new moodle_url('/login/index.php', array('sesskey'=>sesskey())), get_string('login') ?> " > <?php echo get_string('login') ?></a>	

								<?php
								
								}else{
								
								?>
									<a href="<?php echo new moodle_url('/login/logout.php', array('sesskey'=>sesskey())), get_string('logout') ?> " > <?php echo get_string('logout') ?></a>	
									
								<?php
								}
								?>								
							</li>
							<li>
						        <div class="navbutton"> <?php echo $PAGE->button; ?></div>
						    </li>
						</ul>
					</div>
				</div>
			<?php }
		echo $PAGE->headingmenu;
	   ?>
      </div>
    </div>

<div class="clearfix"></div>
    <div id="page-content" class="clearfix">
        <div id="region-main-box">
        
                                      <?php if ($hasnavbar) { ?>
            <div class="navbar-wrapp clearfix">
              <div class="navbar">
                <div class="breadcrumb"><?php echo $OUTPUT->navbar(); ?></div>
              </div>  
            </div>
        <?php } ?>
        
            <div id="region-post-box">
                <div id="region-main-wrap">
                    <div id="region-main">
                        <div class="region-content">
                           <?php if($CFG->version <= 2012050200)
                            echo core_renderer::MAIN_CONTENT_TOKEN;
                           else
                            echo $OUTPUT->main_content(); ?>	
                        </div>
                    </div>
                </div>

                <?php if ($hassidepre) { ?>
                <div id="region-pre" class="block-region">
                    <div class="region-content">
                        <?php echo $OUTPUT->blocks_for_region('side-pre') ?>
                    </div>
                </div>
                <?php } ?>

                <?php if ($hassidepost) { ?>
                <div id="region-post" class="block-region">
                    <div class="region-content">
                        <?php echo $OUTPUT->blocks_for_region('side-post') ?>
                    </div>
                </div>
                <?php } ?>
            </div>
        </div>
        <div class="clearfix"></div>
       
    </div>
</div>     



<!-- START OF FOOTER -->
   <div id="page-footer" style="background: #174da1">
     <div id="footer-wrap">   
     <?php if ($hassocialnetworks) {?>
            
                <?php
                    $topsettings = $this->page->get_renderer('theme_hubris','topsettings');
        			if (!empty($PAGE->theme->settings->socialnetworks)) {?>
        			    <div class="ftr-left">
					         <?php echo $topsettings->social_networks(); ?>
					         <div class="txt">Social networks</div>
                               <div class="iconpart">
                                 <div class="social-icon"><?php {?><a href="https://www.facebook.com/"><img src="<?php echo $OUTPUT->pix_url('social/f', 'theme')?>" alt="" /></a><?php }?></div>
                                 <div class="social-icon"><?php {?><a href="http://twitter.com/"><img src="<?php echo $OUTPUT->pix_url('social/t', 'theme')?>" alt="" /></a><?php }?></div>
                                 <div class="social-icon"><?php {?><a href="https://accounts.google.com/"><img src="<?php echo $OUTPUT->pix_url('social/g', 'theme')?>" alt="" /></a><?php }?></div>
                                 <div class="social-icon"><?php {?><a href="http://www.linkedin.com/"><img src="<?php echo $OUTPUT->pix_url('social/in', 'theme')?>" alt="" /></a><?php }?></div>
                               </div>       
						      <?php } ?>
						      </div>
                          <?php } ?>

      <div class="ftr-rt">
        <p class="helplink">
        <?php echo page_doc_link(get_string('moodledocslink')) ?>
        </p>
        <div style="text-align:center;width: 100%; color:#FFF;font-family: Verdana;font-weight: bold;padding-top: 45px;">  
          <div style="font-size:30px;">MOPE</div>
          <div style="font-size:12px;padding-top: 15px;">
                    PASEO GENERAL MARTÍNEZ CAMPOS, 20 28010 MADRID 
                    <span style="margin-left:5px;">                        
                        <a href="mailto:info@mope.es" style="text-decoration:underline;">
                            info@mope.es
                        </a> 
                    </span>
                    <span style="margin-left:10px;">91 752 79 59</span>
          </div>
        </div>
        <?php
//        echo $OUTPUT->login_info();
        if(!$is_disable_moodlelogo){
			 echo $OUTPUT->home_link();        	
        }
      
        echo $OUTPUT->standard_footer_html();
        ?>
        <!--<p class="maharathemes"><a name="MoodleThemes" title="Moodle Themes" href="http://www.moodlethemes.com/">Moodle Themes</a></p>-->
    </div>
    </div>
    </div>
     <div class="clearfix"></div>    
</div>

<?php echo $OUTPUT->standard_end_of_body_html();
// -----code for back to top----------------------
if (!empty($PAGE->theme->settings->backtotop)) {
?>
<div id="back-to-top" style="display: none;"> 
    <a class="arrow" href="#" title="<?php echo get_string('backtotop', 'theme_hubris')?>"></a> 
</div>
<?php }?>
</body>
</html>