<?php

/**
 * this page is property of vidyamntra pvt.ltd
 * this one is inspired from decaf's lib.php
 * 
 */


require_once($CFG->libdir.'/formslib.php');

function hubris_require_course_login($courseorid, $autologinguest = true, $cm = NULL, $setwantsurltome = true, $preventredirect = true) {
    global $CFG, $SITE;
    $issite = (is_object($courseorid) and $courseorid->id == SITEID)
          or (!is_object($courseorid) and $courseorid == SITEID);
    if ($issite && !empty($cm) && !($cm instanceof cm_info)) {
        // note: nearly all pages call get_fast_modinfo anyway and it does not make any
        // db queries so this is not really a performance concern, however it is obviously
        // better if you use get_fast_modinfo to get the cm before calling this.
        if (is_object($courseorid)) {
            $course = $courseorid;
        } else {
            $course = clone($SITE);
        }
        $modinfo = get_fast_modinfo($course);
        $cm = $modinfo->get_cm($cm->id);
    }
    if (!empty($CFG->forcelogin)) {
        // login required for both SITE and courses
        hubris_require_login($courseorid, $autologinguest, $cm, $setwantsurltome, $preventredirect);

    } else if ($issite && !empty($cm) and !$cm->uservisible) {
        // always login for hidden activities
        hubris_require_login($courseorid, $autologinguest, $cm, $setwantsurltome, $preventredirect);

    } else if ($issite) {
              //login for SITE not required
        if ($cm and empty($cm->visible)) {
            // hidden activities are not accessible without login
            hubris_require_login($courseorid, $autologinguest, $cm, $setwantsurltome, $preventredirect);
        } else if ($cm and !empty($CFG->enablegroupmembersonly) and $cm->groupmembersonly) {
            // not-logged-in users do not have any group membership
            hubris_require_login($courseorid, $autologinguest, $cm, $setwantsurltome, $preventredirect);
        } else {
            // We still need to instatiate PAGE vars properly so that things
            // that rely on it like navigation function correctly.
            if (!empty($courseorid)) {
                if (is_object($courseorid)) {
                    $course = $courseorid;
                } else {
                    $course = clone($SITE);
                }
                if ($cm) {
                    if ($cm->course != $course->id) {
                        throw new coding_exception('course and cm parameters in require_course_login() call do not match!!');
                    }
                }
            }
            return;
        }

    } else {
        // course login always required
        hubris_require_login($courseorid, $autologinguest, $cm, $setwantsurltome, $preventredirect);
    }
}

function hubris_require_login($courseorid = NULL, $autologinguest = true, $cm = NULL, $setwantsurltome = true, $preventredirect = false) {
    global $CFG, $SESSION, $USER, $FULLME, $DB;

    // setup global $COURSE, themes, language and locale
    if (!empty($courseorid)) {
        if (is_object($courseorid)) {
            $course = $courseorid;
        } else if ($courseorid == SITEID) {
            $course = clone($SITE);
        } else {
            $course = $DB->get_record('course', array('id' => $courseorid), '*', MUST_EXIST);
        }
        if ($cm) {
            if ($cm->course != $course->id) {
                throw new coding_exception('course and cm parameters in require_login() call do not match!!');
            }
            // make sure we have a $cm from get_fast_modinfo as this contains activity access details
            if (!($cm instanceof cm_info)) {
                // note: nearly all pages call get_fast_modinfo anyway and it does not make any
                // db queries so this is not really a performance concern, however it is obviously
                // better if you use get_fast_modinfo to get the cm before calling this.
                $modinfo = get_fast_modinfo($course);
                $cm = $modinfo->get_cm($cm->id);
            }
        }
    } else {
        // do not touch global $COURSE via $PAGE->set_course(),
        // the reasons is we need to be able to call require_login() at any time!!
        $course = $SITE;
        if ($cm) {
            throw new coding_exception('cm parameter in require_login() requires valid course parameter!');
        }
    }

    // If the user is not even logged in yet then make sure they are
    if (!isloggedin()) {
        if ($autologinguest and !empty($CFG->guestloginbutton) and !empty($CFG->autologinguests)) {
            if (!$guest = get_complete_user_data('id', $CFG->siteguest)) {
                // misconfigured site guest, just redirect to login page
                redirect(get_login_url());
                exit; // never reached
            }
            $lang = isset($SESSION->lang) ? $SESSION->lang : $CFG->lang;
            complete_user_login($guest);
            $USER->autologinguest = true;
            $SESSION->lang = $lang;
        } else {
            //NOTE: $USER->site check was obsoleted by session test cookie,
            //      $USER->confirmed test is in login/index.php
            if ($preventredirect) {
                throw new require_login_exception('You are not logged in');
            }

            if ($setwantsurltome) {
                // TODO: switch to PAGE->url
                $SESSION->wantsurl = $FULLME;
            }
            if (!empty($_SERVER['HTTP_REFERER'])) {
                $SESSION->fromurl  = $_SERVER['HTTP_REFERER'];
            }
            redirect(get_login_url());
            exit; // never reached
        }
    }

    // loginas as redirection if needed
    if ($course->id != SITEID and session_is_loggedinas()) {
        if ($USER->loginascontext->contextlevel == CONTEXT_COURSE) {
            if ($USER->loginascontext->instanceid != $course->id) {
                print_error('loginasonecourse', '', $CFG->wwwroot.'/course/view.php?id='.$USER->loginascontext->instanceid);
            }
        }
    }

    // check whether the user should be changing password (but only if it is REALLY them)
    if (get_user_preferences('auth_forcepasswordchange') && !session_is_loggedinas()) {
        $userauth = get_auth_plugin($USER->auth);
        if ($userauth->can_change_password() and !$preventredirect) {
            $SESSION->wantsurl = $FULLME;
            if ($changeurl = $userauth->change_password_url()) {
                //use plugin custom url
                redirect($changeurl);
            } else {
                //use moodle internal method
                if (empty($CFG->loginhttps)) {
                    redirect($CFG->wwwroot .'/login/change_password.php');
                } else {
                    $wwwroot = str_replace('http:','https:', $CFG->wwwroot);
                    redirect($wwwroot .'/login/change_password.php');
                }
            }
        } else {
            print_error('nopasswordchangeforced', 'auth');
        }
    }

    // Check that the user account is properly set up
    if (user_not_fully_set_up($USER)) {
        if ($preventredirect) {
            throw new require_login_exception('User not fully set-up');
        }
        $SESSION->wantsurl = $FULLME;
        redirect($CFG->wwwroot .'/user/edit.php?id='. $USER->id .'&amp;course='. SITEID);
    }

    // Make sure the USER has a sesskey set up. Used for CSRF protection.
    sesskey();

    // Do not bother admins with any formalities
    if (is_siteadmin()) {
        return;
    }

    // Fetch the system context, the course context, and prefetch its child contexts
    $sysctx = get_context_instance(CONTEXT_SYSTEM);
    $coursecontext = get_context_instance(CONTEXT_COURSE, $course->id, MUST_EXIST);
    if ($cm) {
        $cmcontext = get_context_instance(CONTEXT_MODULE, $cm->id, MUST_EXIST);
    } else {
        $cmcontext = null;
    }

    // make sure the course itself is not hidden
    if ($course->id == SITEID) {
        // frontpage can not be hidden
    } else {
        if (is_role_switched($course->id)) {
            // when switching roles ignore the hidden flag - user had to be in course to do the switch
        } else {
            if (!$course->visible and !has_capability('moodle/course:viewhiddencourses', $coursecontext)) {
                // originally there was also test of parent category visibility,
                // BUT is was very slow in complex queries involving "my courses"
                // now it is also possible to simply hide all courses user is not enrolled in :-)
                if ($preventredirect) {
                    throw new require_login_exception('Course is hidden');
                }
                notice(get_string('coursehidden'), $CFG->wwwroot .'/');
            }
        }
    }

    // is the user enrolled?
    if ($course->id == SITEID) {
        // everybody is enrolled on the frontpage

    } else {
        if (session_is_loggedinas()) {
            // Make sure the REAL person can access this course first
            $realuser = session_get_realuser();
            if (!is_enrolled($coursecontext, $realuser->id, '', true) and !is_viewing($coursecontext, $realuser->id) and !is_siteadmin($realuser->id)) {
                if ($preventredirect) {
                    throw new require_login_exception('Invalid course login-as access');
                }
                echo $OUTPUT->header();
                notice(get_string('studentnotallowed', '', fullname($USER, true)), $CFG->wwwroot .'/');
            }
        }

        // very simple enrolment caching - changes in course setting are not reflected immediately
        if (!isset($USER->enrol)) {
            $USER->enrol = array();
            $USER->enrol['enrolled'] = array();
            $USER->enrol['tempguest'] = array();
        }

        $access = false;

        if (is_viewing($coursecontext, $USER)) {
            // ok, no need to mess with enrol
            $access = true;

        } else {
            if (isset($USER->enrol['enrolled'][$course->id])) {
                if ($USER->enrol['enrolled'][$course->id] == 0) {
                    $access = true;
                } else if ($USER->enrol['enrolled'][$course->id] > time()) {
                    $access = true;
                } else {
                    //expired
                    unset($USER->enrol['enrolled'][$course->id]);
                }
            }
            if (isset($USER->enrol['tempguest'][$course->id])) {
                if ($USER->enrol['tempguest'][$course->id] == 0) {
                    $access = true;
                } else if ($USER->enrol['tempguest'][$course->id] > time()) {
                    $access = true;
                } else {
                    //expired
                    unset($USER->enrol['tempguest'][$course->id]);
                    $USER->access = remove_temp_roles($coursecontext, $USER->access);
                }
            }

            if ($access) {
                // cache ok
            } else if (is_enrolled($coursecontext, $USER, '', true)) {
                // active participants may always access
                // TODO: refactor this into some new function
                $now = time();
                $sql = "SELECT MAX(ue.timeend)
                          FROM {user_enrolments} ue
                          JOIN {enrol} e ON (e.id = ue.enrolid AND e.courseid = :courseid)
                          JOIN {user} u ON u.id = ue.userid
                         WHERE ue.userid = :userid AND ue.status = :active AND e.status = :enabled AND u.deleted = 0
                               AND ue.timestart < :now1 AND (ue.timeend = 0 OR ue.timeend > :now2)";
                $params = array('enabled'=>ENROL_INSTANCE_ENABLED, 'active'=>ENROL_USER_ACTIVE,
                                'userid'=>$USER->id, 'courseid'=>$coursecontext->instanceid, 'now1'=>$now, 'now2'=>$now);
                $until = $DB->get_field_sql($sql, $params);
                if (!$until or $until > time() + ENROL_REQUIRE_LOGIN_CACHE_PERIOD) {
                    $until = time() + ENROL_REQUIRE_LOGIN_CACHE_PERIOD;
                }

                $USER->enrol['enrolled'][$course->id] = $until;
                $access = true;

                // remove traces of previous temp guest access
                $USER->access = remove_temp_roles($coursecontext, $USER->access);

            } else {
                $instances = $DB->get_records('enrol', array('courseid'=>$course->id, 'status'=>ENROL_INSTANCE_ENABLED), 'sortorder, id ASC');
                $enrols = enrol_get_plugins(true);
                // first ask all enabled enrol instances in course if they want to auto enrol user
                foreach($instances as $instance) {
                    if (!isset($enrols[$instance->enrol])) {
                        continue;
                    }
                    // Get a duration for the guestaccess, a timestamp in the future or false.
                    $until = $enrols[$instance->enrol]->try_autoenrol($instance);
                    if ($until !== false) {
                        $USER->enrol['enrolled'][$course->id] = $until;
                        $USER->access = remove_temp_roles($coursecontext, $USER->access);
                        $access = true;
                        break;
                    }
                }
                // if not enrolled yet try to gain temporary guest access
                if (!$access) {
                    foreach($instances as $instance) {
                        if (!isset($enrols[$instance->enrol])) {
                            continue;
                        }
                        // Get a duration for the guestaccess, a timestamp in the future or false.
                        $until = $enrols[$instance->enrol]->try_guestaccess($instance);
                        if ($until !== false) {
                            $USER->enrol['tempguest'][$course->id] = $until;
                            $access = true;
                            break;
                        }
                    }
                }
            }
        }

        if (!$access) {
            if ($preventredirect) {
                throw new require_login_exception('Not enrolled');
            }
            $SESSION->wantsurl = $FULLME;
            redirect($CFG->wwwroot .'/enrol/index.php?id='. $course->id);
        }
    }

    // Check visibility of activity to current user; includes visible flag, groupmembersonly,
    // conditional availability, etc
    if ($cm && !$cm->uservisible) {
        if ($preventredirect) {
            throw new require_login_exception('Activity is hidden');
        }
        redirect($CFG->wwwroot, get_string('activityiscurrentlyhidden'));
    }
}


class hubris_expand_navigation extends global_navigation {

    /** @var array */
    protected $expandable = array();

    /**
     * Constructs the navigation for use in AJAX request
     */
    public function __construct($page, $branchtype, $id) {
        $this->page = $page;
        $this->cache = new navigation_cache(NAVIGATION_CACHE_NAME);
        $this->children = new navigation_node_collection();
        $this->branchtype = $branchtype;
        $this->instanceid = $id;
        $this->initialise();
    }
    /**
     * Initialise the navigation given the type and id for the branch to expand.
     *
     * @param int $branchtype One of navigation_node::TYPE_*
     * @param int $id
     * @return array The expandable nodes
     */
    public function initialise() {
        global $CFG, $DB, $SITE;

        if ($this->initialised || during_initial_install()) {
            return $this->expandable;
        }
        $this->initialised = true;

        $this->rootnodes = array();
        $this->rootnodes['site']      = $this->add_course($SITE);
        $this->rootnodes['courses'] = $this->add(get_string('courses'), null, self::TYPE_ROOTNODE, null, 'courses');
        
        $this->expand($this->branchtype, $this->instanceid);
    }

    public function expand($branchtype, $id) {
        global $CFG, $DB, $PAGE;
        static $hubris_expanded_courses = array();
        // Branchtype will be one of navigation_node::TYPE_*
        switch ($branchtype) {
            case self::TYPE_CATEGORY :
                $this->load_all_categories($id);
                $limit = 20;
                if (!empty($CFG->navcourselimit)) {
                    $limit = (int)$CFG->navcourselimit;
                }
                $courses = $DB->get_records('course', array('category' => $id), 'sortorder','*', 0, $limit);
                foreach ($courses as $course) {
                    $this->add_course($course);
                }
                break;
            case self::TYPE_COURSE :
                $course = $DB->get_record('course', array('id' => $id), '*', MUST_EXIST);
                try {
                    hubris_require_course_login($course);
                    //$this->page = $PAGE;
                    $this->page->set_context(get_context_instance(CONTEXT_COURSE, $course->id));
                    $coursenode = $this->add_course($course);
                    $this->add_course_essentials($coursenode, $course);
                    if ($this->format_display_course_content($course->format) && $PAGE->course->id == $course->id) {
                        $this->load_course_sections($course, $coursenode);
                    }
                } catch(require_login_exception $rle) {
                    $coursenode = $this->add_course($course);
                }
                break;
            case self::TYPE_SECTION :
                $sql = 'SELECT c.*, cs.section AS sectionnumber
                        FROM {course} c
                        LEFT JOIN {course_sections} cs ON cs.course = c.id
                        WHERE cs.id = ?';
                $course = $DB->get_record_sql($sql, array($id), MUST_EXIST);
                try {
                    hubris_require_course_login($course);
                    //$this->page = $PAGE;
                    $this->page->set_context(get_context_instance(CONTEXT_COURSE, $course->id));
                    if(!array_key_exists($course->id, $hubris_expanded_courses)) {
                        $coursenode = $this->add_course($course);
                        $this->add_course_essentials($coursenode, $course);
                        $hubris_expanded_courses[$course->id] = $this->load_course_sections($course, $coursenode);
                    }
                    $sections = $hubris_expanded_courses[$course->id];
                    if(method_exists($this,'generate_sections_and_activities')) {
                        list($sectionarray, $activities) = $this->generate_sections_and_activities($course);
                        $activitynodes = $this->load_section_activities($sections[$course->sectionnumber]->sectionnode, $course->sectionnumber, $activities);
                    } else {
                        // pre-Moodle 2.1
                        $activitynodes = $this->load_section_activities($sections[$course->sectionnumber]->sectionnode, $course->sectionnumber, get_fast_modinfo($course));
                    }
                    foreach ($activitynodes as $id=>$node) {
                        // load all section activities now
                        $cm_stub = new stdClass();
                        $cm_stub->id = $id;
                        $this->load_activity($cm_stub, $course, $node);
                    }
                } catch(require_login_exception $rle) {
                    $coursenode = $this->add_course($course);
                }
                break;
            case self::TYPE_ACTIVITY :
                // Now expanded above, as part of the section expansion
                break;
            default:
                throw new Exception('Unknown type');
                return $this->expandable;
        }
        $this->find_expandable($this->expandable);
        return $this->expandable;
    }

    public function get_expandable() {
        return $this->expandable;
    }
}

class hubris_dummy_page extends moodle_page {
    /**
     * REALLY Set the main context to which this page belongs.
     * @param object $context a context object, normally obtained with get_context_instance.
     */
    public function set_context($context) {
        if ($context === null) {
            // extremely ugly hack which sets context to some value in order to prevent warnings,
            // use only for core error handling!!!!
            if (!$this->_context) {
                $this->_context = get_context_instance(CONTEXT_SYSTEM);
            }
            return;
        }
        $this->_context = $context;
    }
}

/**
 * display the the menus according to position of menu
 * $apage contains the moodle $PAGE object
 * $siteadmin contains the site administration menu
 * $navigation contains the navigation menu
 * $hascustommenu contains the true or false value
 * $custommenu contains the custom menu
 */
function hubris_position_menus ($siteadmin, $navigation, $hascustommenu, $custommenu){
	global $PAGE;
     $menus= array();
	 //var_dump($PAGE->theme->settings);exit;	  
	//pos is the postion of menu 
 	if(!empty($PAGE->theme->settings->menu_administration)){
    		  $pos = $PAGE->theme->settings->menu_administration;   
    		  $menus[$pos] = 'menu_settings_nav';
    	 }
	 	  
 	if (!empty($PAGE->theme->settings->menu_navigation)){
    		$pos = $PAGE->theme->settings->menu_navigation; 
    		$menus[$pos] = 'menu_navigation';
    	}

    	if(!empty($PAGE->theme->settings->menu_custom)){
    		$pos = $PAGE->theme->settings->menu_custom;
    		$menus[$pos] = 'menu_custom';
    	}
    	
	//echo $home;
	//echo $login_out;
	if(count($menus) >= 1){
		ksort($menus);
			foreach($menus as $stat=>$menupos){
				if($stat>0)
				switch($menupos){
					case 'menu_settings_nav':
				        echo $siteadmin;
				        break;
				    case 'menu_navigation':
				        echo $navigation;
				        break;
				    case 'menu_custom':
				    	if ($hascustommenu){
				        	//echo '<div id="custommenucontainer" class="mynavbar">'.$custommenu.'</div>';
				        	echo $custommenu;
				        	//$m->add(strftime("%A, %d %B %Y"),new moodle_url('/calendar/view.php'),get_string('today'),999999);
				        	//echo strftime("%A, %d %B %Y");
				    	}
				        break;
					
				}
				
			}
 	}
 	
}

/*
 * This fucntion initialise the positonchanger on yui
 * 
 */
/*function hubris_initialise_positionchanger(moodle_page $page){
	$page->requires->yui_module('moodle-theme_hubris-positionChanger', 'M.theme_hubris.initPositionChanger', array(array('div'=>'#colourswitcher')));
}*/
 



//-------------------------code for custom menu mangae-----------------------------------------------------------------------------


/**
 * Themenu class
 *
 * This class is used to operate themenu that can be rendered for the page.
 * Themenu configured form custommenu (if exist). It provide user interface
 * to manage menu items and then converted onto moodle formate.
 *
 * To configure the themenu:
 *     Settings: Administration > Appearance > Themes > {Themename}
 *
 * @since     Moodle 2.01
 */
class hubris_vm_menu{
	
	public static $displaylist=array();
	
	/**
     * Returns the custom menu if one has been set
     *
     * A themenu can be configured by browsing to
     *    Settings: Administration > Appearance > Themes > {themename}
     *
     * @return string
     */
	public function custom_menu() {
	    global $CFG;
	    if (empty($CFG->custommenuitems)) {
	        return '';
	    }
	    //$custommenu = new custom_menu();
	        
	       // return $this->render_custom_menu($custommenu);
	        $custommenu = new custom_menu($CFG->custommenuitems, current_language());
        return $this->render_custom_menu($custommenu);
    }
	
    /**
     * Renders a custom menu object (located in outputcomponents.php)
     *
     * The custom menu this method produces used in 'themenu'
     *
     * @staticvar int $menucount
     * @staticvar int $displaylist
     * @param custom_menu $menu
     * @return array
     */
 	public function render_custom_menu(custom_menu $menu) {
        static $menucount = 0;$depth=0;$weight=1;static $mid = 0;static $parent = 0;
        // If the menu has no children return an empty string
        if (!$menu->has_children()) { 
            return '';
        }
        // Increment the menu count. This is used for ID's that get worked with
        // in JavaScript as is essential
        $menucount++;
   
        foreach ($menu->get_children() as $item) {
            $this->render_custom_menu_item($item,$parent,$depth,$weight);
            $weight++;
            
        }
        
        return self::$displaylist;
    }
    
    /**
     * Renders a custom menu node as part of a submenu
     *
     * The array of object this method produces convert the moodle menu
     * object into a simple object used in 'themenu' 
     *
     * @see render_custom_menu()
     *
     * @staticvar array $displaylist
     * @param custom_menu_item $menunode
     * @return array
     */
	public function render_custom_menu_item(custom_menu_item $menunode,$parent,$depth,$weight) {
        // Required to ensure we get unique trackable id's
        static $submenucount = 0;$content =''; 
        static $mid; 
        $menuobj=new stdClass();
        
        if ($menunode->has_children()) {
            // If the child has menus render it as a sub menu
            $submenucount++;
            $mid++;
            
            
            if ($menunode->get_url() !== null) {
                $url = $menunode->get_url();
            } else {
                $url = '#cm_submenu_'.$submenucount;
            }
            
            $link=(string)$url;	//typecasting form object to string
            //$link=convert_url_formate($url);
            $menuobj->name=$menunode->get_text();
            $menuobj->link=$link;
            $menuobj->title=$menunode->get_title();
            $menuobj->visible=1;
            $menuobj->parent=$parent;
            $menuobj->path='/'.$parent;
            $menuobj->depth=$depth;
            $menuobj->weight=$weight;
            $menuobj->id=$mid;
            self::$displaylist[] = $menuobj;
			unset($link);
            unset($menuobj);
            
            $depth++;
            $parent=$mid;
            
            foreach ($menunode->get_children() as $menunode) { 
            	$this->render_custom_menu_item($menunode,$parent,$depth,$weight);
            }
        } else {
            // The node doesn't have children so produce a final menuitem
            $mid++;
            if ($menunode->get_url() !== null) {
                $url = $menunode->get_url();
            } else {
                $url = '#';
            }
            //$pid=$menunode->get_parent();
            $link=(string)$url;				//typecasting form object to string
            $menuobj->name=$menunode->get_text();
            $menuobj->link=$link;
            $menuobj->title=$menunode->get_title();
            $menuobj->visible=1;
            $menuobj->parent=$parent;
            $menuobj->path='/'.$parent;
            $menuobj->depth=$depth;
            $menuobj->weight=$weight;
            $menuobj->id=$mid;
            self::$displaylist[] = $menuobj;
            unset($link);
            unset($menuobj);
        }
        
        // Return the sub menu
        return self::$displaylist;
    }
}

/**
 * Convert submitted value (after changing the position)
 *  of themenu data in moodle formate (\n seperated string).
 *  
 *  @param array $data menu detail(name,url,parent....)
 *  @return string new line separate menu node list
 */

function hubris_convert_menu_to_moodle_menu($data){
	$menustring=""; $menupath=array();$hyphen=0;
	
	foreach($data as $menunode){
	
		$menupath=hubris_serch_array_value($menunode['menuid']);
		
		if($menunode['pmenuid']!=0){
			$hyphen=hubris_count_depth_of_menu($data,$menunode['pmenuid'],$c=1);
		}
		while($hyphen>0){
			$menustring .='-';
			$hyphen--;
		}
		$menustring .= $menupath->name;
		if($menupath->link)
			$menustring .= "|".$menupath->link;
		if($menupath->title)
			$menustring .= "|".$menupath->title;
		$menustring .="\n";	
		unset($menupath);
	}
	return trim($menustring);
}

/**
 * 
 * Count depth of given node by iterating parent
 * @param array $menu (themenu saved data)
 * @param int $pid parent id of node
 * @param int $ctr count depth(or parent)
 * @return int degree of depth
 */


function hubris_count_depth_of_menu($menu,$pid,$ctr){
	$node=$menu['menuid:'.$pid];
	if($node['pmenuid']){
		$ctr+=1;
		$ctr=hubris_count_depth_of_menu($menu,$node['pmenuid'],$ctr);
	}
	return $ctr;
}
	


/**
 * 
 * Search for id in themenu(vmmenu) array of object
 * and then return that node wihich id match
 * @param array $menuarray
 * @param int $mid menu node id
 * @return array $value menu node 
 */

function hubris_serch_array_value($mid){
	$vm=new hubris_vm_menu();
	$menuarray=$vm->custom_menu();
	foreach($menuarray as $value){
		if($value->id==$mid)
		 return $value;
	}	
	
}

/**
 * Convet moodle menu in an array and then serach node for deletion
 * Then delete node from array and convert into string(moodle menu formate)
 * @param int $id menu node id 
 * @return string $str menu list
 */
function hubris_delete_menu($id){
	global $DB;$str="";
	$i=$id-1;
	
	$mmenu = $DB->get_record('config', array('name'=>'custommenuitems'));
	$menunode = explode("\n", $mmenu->value);
	//var_dump($menunode);
	foreach($menunode as $name){
		if($name!=$menunode[$i])
			$str .= $name."\n";
	}
	//echo $str;exit;
	return trim($str);
}

/**
 * 
 * Create menu add/edit form through quickform
 * @author pinky
 *
 */

class hubris_menu_edit_form extends moodleform {
    

    function definition() {
        global $CFG, $DB;

        $mform    = $this->_form;

        $systemcontext   = get_context_instance(CONTEXT_SYSTEM);
        
        $mform->addElement('header','general', get_string('general', 'form'));
        $mform->addElement('text','menuname', get_string('menuname', "theme_$CFG->theme"),'maxlength="254" size="50"');
        $mform->addRule('menuname', get_string('missingmenuname', "theme_$CFG->theme"), 'required', null, 'client');
        $mform->setType('menuname', PARAM_MULTILANG);
        
       
        //$mform->addElement('text','menuurl', get_string('menuurl', "theme_$CFG->theme"),'maxlength="254" size="50" ');
        $mform->addElement('text','menuurl', get_string('menuurl', "theme_$CFG->theme"),'onclick="if(this.value==\'http://\'){ this.value=\'\' }" value="http://" maxlength="254" size="50" ');
        //$mform->addElement('static', 'menuurlhttp', '', get_string('urltext', "theme_$CFG->theme"), 'class="logininfo"');
        $mform->setType('menuurl', PARAM_MULTILANG);
        
        $mform->addElement('text','menutitle', get_string('menutitle', "theme_$CFG->theme"),'maxlength="254" size="50" ');
        $mform->setType('menutitle', PARAM_MULTILANG);
        
        $this->add_action_buttons();
        $mform->addElement('hidden', 'id', null);
        $mform->setType('id', PARAM_INT);
        
    }
    
    
    
	function validation($data, $files) {
        $errors = parent::validation($data, $files);
        $menuurl = $data['menuurl'];
        
        if($menuurl!='#'){
	        if(!$url=parse_url($menuurl)){
	        	$errors['menuurl']="Invalid url";
	        }
	        if(!empty($url['scheme']) && empty($url['host'])){
	        	$errors['menuurl']="Invalid url";
	        }
        }
        return $errors;
    }
    
}

/**
 * Add new node in existing value if any 
 * else create new menu node through themenu
 * and save it in mdl_config table 
 * 
 * @param object $data menu node detail
 */
function hubris_add_menu_to_db($data){
	global $DB;
		
	$mmenu = $DB->get_record('config', array('name'=>'custommenuitems'));
	
	if(empty($mmenu)){
		// menu does not exist
		$mmenu = new stdClass();
        $mmenu->name = 'custommenuitems';
        $mmenu->value = $data->menuname."|".$data->menuurl;
        $DB->insert_record('config', $mmenu);
	}else{
		$mmenu->value .="\n".$data->menuname;
		if($data->menuurl)
			$mmenu->value .="|".$data->menuurl;
		else 
			$mmenu->value .="|#";
		if($data->menutitle)
			$mmenu->value .="|".$data->menutitle;
			
		$DB->update_record('config', $mmenu);
		unset($mmenu);
	}
	
}

/**
 * Update existing menu node value in db
 * 
 * @param object $data edited menu node detail
 * @return string new line seperated menulist
 */

function hubris_update_menu($data){
	global $DB;$newnode="";$str ="";
	
	$mmenu = $DB->get_record('config', array('name'=>'custommenuitems'));
	if(!empty($mmenu)){
		$menunode = explode("\n", $mmenu->value);
		$i=$data->id-1;
		$hyphen=hubris_split_menu_line ($menunode[$i]);
		if($hyphen){
			while($hyphen>0){
				$newnode .= '-';
				$hyphen--;
			}
		}
		
		$newnode .=$data->menuname;
		if($data->menuurl)
			$newnode .="|".$data->menuurl;
		else 
			$mmenu->value .="|#";
		if($data->menutitle)
			$newnode .="|".$data->menutitle; 

		$menunode[$i]=$newnode;
		unset($newnode);
		foreach($menunode as $name){
			$str .= $name."\n";
		}
		$mmenu->value =trim($str);
		unset($str);
		return $mmenu;
					
	}
}

/**
 * 
 * Count no of (-) dash from menu node
 * @param string $string menu node list
 * @return int $i not of dash
 */
function hubris_split_menu_line ($string) {
	$len = strlen($string);
	for ($i=0; $i<$len; $i++) {
		if ($string[$i] != '-') {
		 	return $i;
		}
	}
	return false;
}


//mine code
function hubris_user_settings($css, $theme) {

    // Set the page Site color
    if (empty($theme->settings->sitebgc)) {
        $sitebgc = '#6F6A22'; // default 
    } else {
        $sitebgc = $theme->settings->sitebgc;
    }   
    $css = hubris_set_sitebgc($css, $sitebgc);
    
    // Set the page Link color
    if (empty($theme->settings->linkc)) {
        $linkc = '#e4885b'; // default 
    } else {
        $linkc = $theme->settings->linkc;
    }
    
    $css = hubris_set_linkc($css, $linkc);
    
    // Set the font reference size
    if (empty($theme->settings->fontsizereference)) {
        $fontsizereference = '15'; // default
    } else {
        $fontsizereference = $theme->settings->fontsizereference;
    }
 	
 	$css = hubris_set_fontsizereference($css, $fontsizereference);
 	
    return $css;
}

function hubris_set_fontsizereference($css, $fontsizereference) {
	global $PAGE;
	if (!empty($PAGE->theme->settings->customfontsize) && isset($_COOKIE['yuifont'])){
		$fontsizereference=$_COOKIE['yuifont'];
	}
	//$css =  hubris_mk_height_asbar($fontsizereference, $css);
    $tag = '[[setting:fontsizereference]]';
    $css = str_replace($tag, $fontsizereference.'px', $css);
   	
	return $css;
}

function hubris_set_sitebgc($css, $sitebgc) {
	
    $tag = '[[setting:sitebgc]]';
    $css = str_replace($tag, $sitebgc, $css);
    return $css;
}

function hubris_set_linkc($css, $linkc) {
	
    $tag = '[[setting:linkc]]';
    $css = str_replace($tag, $linkc, $css);
    return $css;
}

?>